Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!

Bug 583626

Summary: net-p2p/qbittorrent-3.3.4-r1: building w/gcc-6: error: stdlib.h: No such file or directory
Product: Gentoo Linux Reporter: Peter Levine <plevine457>
Component: Current packagesAssignee: Markos Chandras (RETIRED) <hwoarang>
Status: RESOLVED FIXED    
Severity: normal CC: jrmalaq, plevine457, qt
Priority: Normal Keywords: PATCH, UPSTREAM
Version: unspecified   
Hardware: All   
OS: Linux   
See Also: https://bugs.gentoo.org/show_bug.cgi?id=582948
Whiteboard:
Package list:
Runtime testing required: ---
Bug Depends on:    
Bug Blocks: 582084    
Attachments: qbittorrent-3.3.4-no-default-incdir.patch
qbittorrent-3.3.4-no-default-incdirs.patch

Description Peter Levine 2016-05-21 00:55:13 UTC
Building net-p2p/qbittorrent-3.3.4-r1 with gcc-6 fails with:

> In file included from /usr/lib/gcc/x86_64-pc-linux-gnu/6.1.0/include/g++-v6/bits/stl_algo.h:59:0,
>                 from /usr/lib/gcc/x86_64-pc-linux-gnu/6.1.0/include/g++-v6/algorithm:62,
>                 from /usr/include/qt5/QtCore/qglobal.h:85,
>                 from /usr/include/qt5/QtCore/qalgorithms.h:37,
>                 from /usr/include/qt5/QtCore/qlist.h:37,
>                 from /usr/include/qt5/QtCore/qstringlist.h:34,
>                 from /usr/include/qt5/QtCore/QStringList:1,
>                 from base/http/requestparser.cpp:32:
>/usr/lib/gcc/x86_64-pc-linux-gnu/6.1.0/include/g++-v6/cstdlib:75:25: fatal >error: stdlib.h: No such file or directory
> #include_next <stdlib.h>

GCC-6 will fail to build with "-isystem /usr/include" (see https://gcc.gnu.org/bugzilla/show_bug.cgi?id=70129).

According to https://bugreports.qt.io/browse/QTBUG-53367 it is the responsibility of maintainers using qmake in their packages to properly filter '/usr/include' from INCLUDEPATH:

"the problem are the broken qmake-based build systems of 3rd party applications, which somehow end up adding /usr/include to INCLUDEPATH. report bugs against these applications."


I submitted a pull request with qbittorrent upstream pending approval:

https://github.com/qbittorrent/qBittorrent/pull/5275
Comment 1 Peter Levine 2016-05-21 01:04:11 UTC
Created attachment 434820 [details, diff]
qbittorrent-3.3.4-no-default-incdir.patch

Patch based on upstream pull request.
Comment 3 Peter Levine 2016-05-24 16:32:54 UTC
Created attachment 435268 [details, diff]
qbittorrent-3.3.4-no-default-incdirs.patch

Patch based on upstream commit:
https://github.com/qbittorrent/qBittorrent/commit/e2bf462a45b32b5b05736736703db24d74aaa0d9
Comment 4 Davide Pesavento gentoo-dev 2016-11-18 16:55:47 UTC
is this fixed in 3.3.7?
Comment 5 matt black 2017-01-23 05:11:15 UTC
Version 3.3.7 builds successfully for me with gcc-6.3.0 on amd64

--- /usr/bin/
>>> /usr/bin/qbittorrent
>>> net-p2p/qbittorrent-3.3.7 merged.
>>> Regenerating /etc/ld.so.cache...

>>> Recording net-p2p/qbittorrent in "world" favorites file...
Comment 6 Davide Pesavento gentoo-dev 2017-01-23 05:17:38 UTC
Thanks. Closing then.